import pygame


def inicializa():
    pygame.init()
    window = pygame.display.set_mode((640, 480), vsync=True, flags=pygame.SCALED)
    pygame.key.set_repeat(50)

    assets = {
    }

    state = {
        'retangulo1_pos': [300, 400],
        'retangulo1_dimen': [100, 50],

        'retangulo2_pos': [300, 400],
        'retangulo2_dimen': [100, 50],

        'cor_colisao': (255, 0, 0)
    }

    return window, assets, state


def finaliza():
    pygame.quit()


def desenha(window: pygame.Surface, assets, state):
    window.fill((0, 0, 0))
    
    pygame.draw.rect(window, state['cor_colisao'], pygame.Rect(state['retangulo1_pos'], state['retangulo1_dimen']))
    pygame.draw.rect(window, state['cor_colisao'], pygame.Rect(state['retangulo2_pos'], state['retangulo2_dimen']))

    pygame.display.update()


def atualiza_estado(state):
    
    for ev in pygame.event.get():
        if ev.type == pygame.QUIT:
            return False
        elif ev.type == pygame.MOUSEMOTION:
            state['retangulo2_pos'] = ev.pos

            # TODO: chamar sua função aqui. Se houver colisao fazer ambos ficarem azuis. Se não houver manter vermelho
    return True


def gameloop(window, assets, state):
    while atualiza_estado(state):
        desenha(window, assets, state)


if __name__ == '__main__':
    window, assets, state = inicializa()
    gameloop(window, assets, state)
    finaliza()